// Copyright (c) 2024 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "scene/SceneItem.hpp"
#include "ui/container/UIContainer.hpp"
#include "ui/elements/UILabel.hpp"
#include "ui/elements/UIRectangle.hpp"

namespace Dawn {
  class VNManager : public SceneComponent {
    protected:
      std::shared_ptr<UIContainer> container;
      std::shared_ptr<UILabel> label;
      std::shared_ptr<UIRectangle> borders;
      std::shared_ptr<UIRectangle> background;
      std::wstring text;

    public:
      std::shared_ptr<UICanvas> canvas;
      std::shared_ptr<TrueTypeTexture> texture;


      void onInit() override;
      void onDispose() override;

      /**
       * Sets the text to display.
       * 
       * @param text The text to display.
       */
      void setText(const std::wstring &text);
  };
}